package ru.landgrafhomyak.db.sql_skeleton_0.api.misc

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table

public interface Column<RUNTIME_TYPE, TABLE_USER_EXTENSION : Any, RUNTIME_KEY : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("name")
	public val name: String

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("type")
	public val type: DatabaseType<RUNTIME_TYPE>

	@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
	@get:JvmName("_getOwner")
	public val _owner: Table<TABLE_USER_EXTENSION, *, RUNTIME_KEY>
}