package ru.landgrafhomyak.db.sql_skeleton_0.api.queries

import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectKey

public interface RawStatement<qUE : Any?, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : _Statement<qUE, DIALECT> {
	public override val uExt: qUE

	public interface Void2Void<qUE : Any?, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Void2Void<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any?>
	}

	public interface Void2Row<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Void2Row<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Void2RowOrNull<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Void2RowOrNull<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Void2Table<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Void2Table<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Params2Void<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Params2Void<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Params2Row<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Params2Row<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Params2RowOrNull<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Params2RowOrNull<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}

	public interface Params2Table<qUE : Any, DIALECT : DialectKey<*, *, *, *, *, *, *, *, *>> : RawStatement<qUE, DIALECT>, _Statement.Params2Table<qUE, DIALECT> {
		override val uExt: qUE

		public interface Constructor<qUE : Any>
	}
}